<template>
  <q-page class="bg-grey-2 q-pa-sm">
    <div class="col-xs-8 col-sm-6 col-md-4 col-lg-3 col-xl-2">
      <q-card class="shadow-up-24 q-pb-xs">
        <q-card-section class="text-white bg-primary">
          <div
            class="text-h6 text-center"
          >
          Documentos
          </div>
        </q-card-section>
        <q-card-section>
          <q-tabs
            v-model="tabs"
            dense
            class="text-grey"
            indicator-color="primary"
            active-color="primary"
            align="justify"
            narrow-indicator
            >
            <q-tab name="documents" label="Documentos"/>
            <q-tab name="information" label="Información"/>
          </q-tabs>
          <q-separator/>
          <q-tab-panels v-model="tabs" animated>
            <q-tab-panel name="documents">
              <q-table
                grid
                :card-container-class="cardContainerClass"
                title="Documentos Estudiantiles"
                :data="form"
                :columns="columns"
                row-key="name"
                hide-header
                :pagination.sync="pagination"
                :rows-per-page-options="rowsPerPageOptions"
              >
                  <template v-slot:bottom>
                  <q-btn label="Atras" class="bg-secondary text-white full-width" icon="undo" style="margin-top: 4%;" @click="Back()"/>
                </template>
                <template v-slot:item="props">
                      <div class="q-pa-xs col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                        <q-card>
                          <q-card-section class="row items-center">
                            <div class="col">
                              {{ props.row.title }}
                            </div>
                            <div class="col">
                              <q-btn round :icon="props.row.icon" :color="props.row.color" style="font-size: 1.5em;" @click="OpenDoc(props.row.url)"/>
                            </div>
                          </q-card-section>
                        </q-card>
                      </div>
                </template>
              </q-table>
            </q-tab-panel>
            <q-tab-panel name="information">
              <q-list bordered>
                <q-expansion-item
                  group="somegroup"
                  icon="people"
                  label="Datos Personales"
                  header-class="text-primary"
                  >
                  <q-card>
                    <q-card-section>
                      <div class="row">
                        <div class="col">
                          <strong>Apelidos:<br/></strong> {{Iform.fullname}}<br/>
                          <strong>Nombres:<br/></strong> {{Iform.name}}<br/>
                          <strong>Aspirante:<br/></strong> {{Iform.carrera}}<br/>
                          <strong>Documento de Identificacion:<br/></strong> {{form.dni}}<br/>
                          <strong>F/N:<br/></strong> {{Iform.date}}<br/>
                          <strong>Edad:<br/></strong> {{Iform.year}}<br/>
                          <strong>Sexo:<br/></strong> {{Iform.sexo}}<br/>
                          <strong>País:<br/></strong> {{Iform.pais}}<br/>
                          <strong>Carrera:<br/></strong> {{Iform.carrera}}<br/>
                          <strong>Email:<br/></strong> {{Iform.email}}<br/>
                        </div>
                        <div class="col">
                          <strong>Nombres del Padre:<br/></strong> {{Iform.father_fullname}}<br/>
                          <strong>Telefono del Padre:<br/></strong> {{Iform.father_phone}}<br/>
                          <strong>Nombres de la Madre:<br/></strong> {{Iform.mother_fullname}}<br/>
                          <strong>Telefono de la Madre:<br/></strong> {{Iform.mother_phone}}<br/>
                          <strong>Dirección:<br/></strong> {{Iform.direction}}<br/>
                          <strong>País de Vivienda:<br/></strong> {{Iform.direction_pais}}<br/>
                          <strong>Estado de Vivienda:<br/></strong> {{Iform.direction_state}}<br/>
                          <strong>Ciudad de Vivienda:<br/></strong> {{Iform.direction_city}}<br/>
                          <strong>Telefono:<br/></strong> {{Iform.phone}}<br/>
                          <strong>Telefono Local:<br/></strong> {{Iform.local_phone}}<br/>
                        </div>
                      </div>
                    </q-card-section>
                  </q-card>
                </q-expansion-item>
                <q-expansion-item
                  group="somegroup"
                  icon="school"
                  label="Datos Academicos"
                  header-class="text-primary"
                  >
                  <q-card>
                    <q-card-section>
                      <div class="row">
                        <div class="col">
                          <strong>Plantel:<br/></strong> {{academic.name}}<br/>
                          <strong>Dependencia:<br/></strong> {{academic.dependency}}<br/>
                          <strong>Especialidad:<br/></strong> {{academic.especiality}}<br/>
                          <strong>Fecha de Graduación:<br/></strong> {{academic.year}}<br/>
                        </div>
                        <div class="col">
                          <strong>Ubicación:<br/></strong> {{academic.ubicate}}<br/>
                          <strong>Sistema:<br/></strong> {{academic.system}}<br/>
                          <template v-if="!academic.superiority_insitute === null">
                            <strong>Estudios Superiores<br/></strong><br/>
                            <strong>Plantel:<br/></strong> {{academic.superiority_insitute}}<br/>
                            <strong>Carrera:<br/></strong> {{academic.superiority_carrera}}<br/>
                          </template>
                        </div>
                      </div>
                    </q-card-section>
                  </q-card>
                </q-expansion-item>
                <q-expansion-item
                  group="somegroup"
                  icon="school"
                  label="Datos Religiosos"
                  header-class="text-primary"
                  v-if="Iform.carrer === 'IUNAV'"
                  >
                  <q-card>
                    <q-card-section v-if="religions.religion">
                      <div class="row">
                        <div class="col">
                          <strong>Religion:<br/></strong> {{religions.type}}<br/>
                          <strong>Asociacion:<br/></strong> {{religions.asociate}}<br/>
                        </div>
                        <div class="col">
                          <strong>Distrito:<br/></strong> {{religions.distitre}}<br/>
                          <strong>Pastor:<br/></strong> {{religions.sherpherd}}<br/>
                        </div>
                      </div>
                    </q-card-section>
                    <q-car-section v-if="!religions.religion">
                      <br/><div class="text-black text-h6 text-center">No posee una Religion</div>
                    </q-car-section>
                  </q-card>
                </q-expansion-item>
                <q-expansion-item
                  group="somegroup"
                  icon="school"
                  label="Datos Eclesiasticos"
                  header-class="text-primary"
                  v-if="Iform.carrer === 'SETAVEN'"
                  >
                  <q-card>
                    <q-card-section>
                      <div class="row">
                        <div class="col">
                          <strong>Adventista de Nacimiento:<br/></strong> {{eclesiastic.adventist_naciment}}<br/>
                          <strong>Asociación:<br/></strong> {{eclesiastic.asociation}}<br/>
                          <strong>Fecha de Bautizo:<br/></strong> {{eclesiastic.bautizate}}<br/>
                          <strong>colportor:<br/></strong> {{eclesiastic.colport}}<br/>
                          <strong>Distrito:<br/></strong> {{eclesiastic.distitre}}<br/>
                        </div>
                        <div class="col">
                          <strong>Pastor:<br/></strong> {{eclesiastic.sherpherd}}<br/>
                          <strong>Pastor que lo Bautizó:<br/></strong> {{eclesiastic.sherpherd_bautizate}}<br/>
                          <strong>Lugar de Bautizo:<br/></strong> {{eclesiastic.state_bautizate}}<br/>
                          <strong>Años bautizado:<br/></strong> {{eclesiastic.years_bautizate}}<br/>
                          <strong>Tareas realizadas del Pastor:<br/></strong> {{eclesiastic.test_sherpherd}}<br/>
                        </div>
                      </div>
                    </q-card-section>
                  </q-card>
                </q-expansion-item>
              </q-list>
            </q-tab-panel>
          </q-tab-panels>
        </q-card-section>
      </q-card>
    </div>
  </q-page>
</template>
<script>
import URl from '../../env'
import { date } from 'quasar'
export default {
  computed: {
    cardContainerClass () {
      if (this.$q.screen.gt.xs) {
        return 'grid-masonry grid-masonry--' + (this.$q.screen.gt.sm ? '3' : '2')
      }

      return 0
    },
    rowsPerPageOptions () {
      if (this.$q.screen.gt.xs) {
        return this.$q.screen.gt.sm ? [4, 8, 12] : [4, 8]
      }

      return [3]
    }
  },
  watch: {
    '$q.screen.name' () {
      this.pagination.rowsPerPage = this.getItemsPerPage()
    }
  },
  data () {
    return {
      general: [],
      Iform: {},
      academic: {},
      religions: {},
      eclesiastic: {},
      tabs: 'documents',
      date: false,
      filter: '',
      form: [],
      copyForm: {},
      columns: [
        {
          name: 'title', label: 'Documento', field: 'title'
        }
      ],
      pagination: {
        page: 1,
        rowsPerPage: this.getItemsPerPage()
      }
    }
  },
  mounted () {
    this.getDocument()
    this.Information()
  },
  methods: {
    Back (url) {
      this.$router.push('/documents_show')
    },
    getDocument () {
      this.form = []
      const cod = this.$route.params.id
      this.$q.loading.show()
      this.$api.get('GetDocuments/' + cod).then(res => {
        this.form = res
        console.log(this.form)
        this.$q.loading.hide()
      })
    },
    Information () {
      const cod = this.$route.params.id
      this.$q.loading.show()
      this.$api.get('GetInformation/' + cod).then(res => {
        this.general = res
        this.Iform = this.general[0].personal[0]
        let fn = this.Iform.date
        this.Iform.date = date.formatDate(fn, 'DD/MM/YYYY')
        this.academic = this.general[0].academic[0]
        fn = this.academic.year
        this.academic.year = date.formatDate(fn, 'DD/MM/YYYY')
        console.log(this.Iform.carrer)
        if (this.Iform.carrer === 'IUNAV') {
          this.religions = this.general[0].religion[0]
          console.log(this.religions)
        } else if (this.Iform.carrer === 'SETAVEN') {
          this.eclesiastic = this.general[0].eclesiastic[0]
          fn = this.eclesiastic.bautizate
          this.eclesiastic.bautizate = date.formatDate(fn, 'DD/MM/YYYY')
          if (this.eclesiastic.adventist_naciment) {
            this.eclesiastic.adventist_naciment = 'Si'
          } else {
            this.eclesiastic.adventist_naciment = 'No'
          }
          if (this.eclesiastic.colport) {
            this.eclesiastic.colport = 'Si'
          } else {
            this.eclesiastic.colport = 'No'
          }
          if (this.eclesiastic.test_sherpherd) {
            this.eclesiastic.test_sherpherd = 'Si'
          } else {
            this.eclesiastic.test_sherpherd = 'No'
          }
        }
        this.$q.loading.hide()
      })
    },
    getItemsPerPage () {
      const { screen } = this.$q
      if (screen.lt.sm) {
        return 13
      }
      if (screen.lt.md) {
        return 13
      }
      return 13
    },
    OpenDoc (dir) {
      const url = (`${URl.url}api/${dir}`)
      console.log(url)
      const link = document.createElement('a')
      link.href = url
      link.target = 'blank'
      link.setAttribute('download', dir)
      document.body.appendChild(link)
      link.click()
    }
  }
}
</script>
